
.data
Parent          db  'Projects',0
PatnP           db  'Pointers\*.ptr',0
;szPointer       db  'Pointers\',0
szColName       db  'Filename',0
szExe           db  '.exe',0
DlgName4        db  'ChkDelProj',0

szMsg01         db  'Could not find an exe in this Folder.', 0Dh,0Ah,0Dh,0Ah
                db  'Or there is more then one exe in this Folder and could', 0Dh,0Ah
                db  'not find one that matches the Folder name', 0Dh,0Ah
                db  'or the displayed File name.',0
szDeleteF       db  'This will delete the seleted file', 0Dh,0Ah
                db  'Do you wish to continue?',0

LibNameCP       db  'Create',0
FuncNameDP      db  'DelProj',0
szDeleteP       db  'This will delete the complete seleted Project.',0Dh,0Ah
                db  'Or just the Project name from the list.',0Dh,0Ah,0Dh,0Ah
                db  'Do you wish to continue?',0
szError7        db  'Are you sure you want to delete the Project.',0
szError8        db  'The Program file(s) are not in the Project Directory.'
                db  0Dh,0Ah
                db  0Dh,0Ah
                db  'Are you sure you want to DELETE the Project?',0
szError9        db  'There was a problem trying to delete the Project.',0
szError10       db  'There was a problem trying to delete the Folder.',0

.data?
hImageListTL    dd  ?
hDir            dd  32  dup(?)
Texe            dd  ?
Tdll            dd  ?
Tlib            dd  ?
Tinc            dd  ?
DeleteSW        dd  ?
DeleteOn        dd  ?
Lev             dd  ?
szPathIn        db  256 dup(?)
szListPath      db  256 dup(?)

.code

;===================================================
; Initialize the Tree and List views procedure
;===================================================
InitTreeList PROC
LOCAL    tvis:TV_INSERTSTRUCT
LOCAL    lvc:LV_COLUMN
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    hBitmap:DWORD, hFind
LOCAL    szWork[256]:BYTE

;WS_EX_CLIENTEDGE
;---------- [Create the control windows] ----------

         INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr TreeClass, NULL,\
                    WS_CHILD or WS_VISIBLE or TVS_HASLINES or TVS_HASBUTTONS or\ 
                    TVS_LINESATROOT or TVS_SHOWSELALWAYS or WS_CLIPSIBLINGS or WS_BORDER,\
                    0, 23, 143, 159, hWnd, 44, hInst, NULL ;0, 23, 133, 160
           test     eax, eax     
             jz     Ret0
            mov     hWndTree, eax 
         INVOKE     SendMessage, hWndTree, TVM_SETTEXTCOLOR, 0, Color.TreeListTC
         INVOKE     SendMessage, hWndTree, TVM_SETBKCOLOR, 0, Color.TreeListBC

         INVOKE     CreateWindowEx, WS_EX_STATICEDGE, addr ListViewClass, NULL,\
                    WS_CHILD or WS_VISIBLE or LVS_REPORT or LVS_SHAREIMAGELISTS or\
                    LVS_SORTASCENDING or LVS_SHOWSELALWAYS or LVS_SINGLESEL or\
                    WS_CLIPSIBLINGS  or WS_CLIPCHILDREN or WS_BORDER,\
                    0, 183, 143, 208, hWnd, 45, hInst, NULL ;0, 183, 133, 208
           test     eax, eax     
             jz     Ret0
            mov     hWndList, eax
         INVOKE     SendMessage, hWndList, LVM_SETTEXTCOLOR, 0, Color.TreeListTC
         INVOKE     SendMessage, hWndList, LVM_SETTEXTBKCOLOR, 0, Color.TreeListBC
         INVOKE     SendMessage, hWndList, LVM_SETBKCOLOR, 0, Color.TreeListBC

            mov     lvc.imask, LVCF_TEXT or LVCF_WIDTH
            mov     lvc.pszText, offset szColName
            mov     lvc.lx, 129
         INVOKE     SendMessage, hWndList, LVM_INSERTCOLUMN, 0, addr lvc

;         INVOKE     SetWindowLong, hWndTree, GWL_ID, 2244
;         INVOKE     ShowWindow, hWndTree, SW_HIDE

         INVOKE     ImageList_Create, 16, 16, ILC_COLOR16, 8, 2
            mov     hImageListTL, eax
         INVOKE     LoadBitmap, hInst, 800
            mov     hBitmap,eax
         INVOKE     ImageList_Add, hImageListTL, hBitmap, NULL
         INVOKE     DeleteObject, hBitmap
         INVOKE     SendMessage, hWndTree, TVM_SETIMAGELIST, 0, hImageListTL
         INVOKE     SendMessage, hWndList, LVM_SETIMAGELIST, LVSIL_SMALL, hImageListTL

         INVOKE     LockWindowUpdate, hWnd          ; Lock Window to avoid flicker
            and     Lev, 0
         INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, TVI_ROOT
            mov     tvis.hParent, NULL
            mov     tvis.hInsertAfter, TVI_ROOT
            mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
            mov     tvis.item.pszText, offset Parent
            mov     tvis.item.iImage, 0
            mov     tvis.item.iSelectedImage, 1
         INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
            mov     ecx, Lev
            mov     hDir[ecx*4], eax
            mov     hParent, eax

         INVOKE     lstrcpy, addr szWork, addr AsmRootDir
         INVOKE     lstrcat, addr szWork, addr PatnP
;INVOKE     MessageBox, NULL, addr szWork, addr AppName, MB_OK

         INVOKE     FindFirstFile, addr szWork, addr FindData
         .if eax == -1
            INVOKE     LockWindowUpdate, 0          ; Unock Window
               jmp     Ret0
         .endif
            mov     hFind, eax
            jmp     Addem

Getem:
         INVOKE     FindNextFile, hFind, addr FindData
           test     eax, eax
             jz     AllDone

Addem:
         INVOKE     lstrlen, addr FindData.cFileName
            sub     eax, 3
         INVOKE     lstrcpyn, addr szWork, addr FindData.cFileName, eax
         INVOKE     LoadTreeView, addr szWork, 0

jmp     xxxx
            mov     eax, hParent
            mov     tvis.hParent, eax
            mov     tvis.hInsertAfter, TVI_LAST
            lea     eax, szWork
            mov     tvis.item.pszText, eax
         INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
 ;           mov     SaveItem, eax
xxxx:

         .if !hItem
              push     eax
            INVOKE     lstrcmpi, addr szWork, addr szProject
               pop     ecx
            .if !eax
                  mov     hItem, ecx
            .endif
         .endif

            jmp     Getem

AllDone:
         INVOKE     FindClose, hFind
         INVOKE     LoadTreeView, addr szWork, 1
;         INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hParent
;         INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, hParent
;         INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hItem
;         INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, hItem
         INVOKE     LockWindowUpdate, 0          ; Unock Window

Ret0:
         xor     eax, eax
         ret

InitTreeList ENDP

;===================================================
; Treeview notify procedure
;===================================================
TreeViewNotify PROC uses ebx edx esi edi wParam:DWORD, lParam
LOCAL    pt:POINT
LOCAL    tvi:TV_ITEM
LOCAL    tvhti:TV_HITTESTINFO
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    szWork[256]:BYTE, szBuff1[64]:BYTE

      .if wParam == 55555
         INVOKE     lstrcpy, addr szWork, addr szListPath
            jmp     FromFirst
      .endif
         mov     eax, lParam
         mov     ebx, (NM_TREEVIEW ptr [eax]).hdr.code
         mov     ecx, (NM_TREEVIEW ptr [eax]).itemNew.hItem
         mov     edx, (NMHDR ptr [eax]).code

      .if edx == NM_RCLICK
            jmp     RightClk
      .endif

      .if ebx == TVN_SELCHANGED
         .if ecx == hParent
            INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, NULL
               jmp     Ret0
         .endif
            mov     hItem, ecx
            mov     tvi.hItem, ecx
            mov     tvi.imask, TVIF_TEXT or TVIF_SELECTEDIMAGE
            lea     eax, szProject
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, NULL, addr tvi
           test     eax,eax
            jz      Ret0

FromFirst:
         INVOKE     lstrcpy, addr szWork, addr AsmRootDir
         INVOKE     lstrcat, addr szWork, addr szPointer
         INVOKE     lstrcat, addr szWork, addr szProject
         INVOKE     lstrcat, addr szWork, addr PatnP+10  ; = .ptr
            mov     ebx, hBuff
         INVOKE     lstrcpy, ebx, addr szWork
           call     ReadF
           test     eax, eax
             js     Ret0
            mov     ecx, BytesR           ; Bytes left to analyze
            mov     esi, fpMem            ; Start address in input buffer
            lea     edi, szWork
            xor     eax, eax
         .while (ecx)
            .if word ptr [esi] == ' :'
                  add     esi, 2
                  sub     ecx, 2
               .break
            .endif
               dec     ecx
               inc     esi
         .endw
         .if !ecx
               jmp     FreeEm
         .endif
         .while (ecx)
               mov     al, byte ptr[esi]
            .if al == 0dh
               .break
            .endif
               mov     byte ptr[edi], al
               dec     ecx
               inc     esi
               inc     edi
         .endw
            mov     byte ptr[edi], 0
         INVOKE     lstrcpy, addr szLoadPath, addr szWork

;         .if sw88   ; Refreash 
;            INVOKE     lstrcpy, addr PathName, addr szWork
;            INVOKE     lstrcat, addr PathName, addr szProjectP
;            INVOKE     lstrcat, addr PathName, addr szAsm
;         .endif

         INVOKE     ReadTheFile, addr szWork

FreeEm:
         INVOKE     GlobalUnlock, fpMem
         INVOKE     GlobalFree, hpMem
            mov     hpMem, 0
      .endif
         jmp     Ret0

;---------- [Delete Project] ----------
RightClk:
      INVOKE     GetCursorPos, addr pt
      INVOKE     ScreenToClient, hWndTree, addr pt
         mov     eax, pt.x
         mov     tvhti.pt.x, eax
         mov     eax, pt.y
         mov     tvhti.pt.y, eax
      INVOKE     SendMessage, hWndTree, TVM_HITTEST, 0, addr tvhti
      .if (tvhti.flags & TVHT_ONITEM)
         INVOKE     ClientToScreen, hWndTree, addr pt
            mov     tvi.imask, TVIF_HANDLE or TVIF_TEXT
            mov     eax, tvhti.hItem
            mov     tvi.hItem, eax
            lea     eax, szBuff1
            mov     tvi.pszText, eax
            mov     tvi.cchTextMax, 64
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, 0, addr tvi
           test     eax,eax
            jz      Ret0
         INVOKE     MessageBox, NULL, addr szDeleteP, addr szBuff1, MB_YESNO or MB_ICONQUESTION
         .if eax == IDNO
               jmp     Ret0
         .endif

         INVOKE     DelProj, addr szBuff1, 4444
         .if eax == 4444    ; Delete confirmed
               mov     DeleteSW, eax
               mov     eax, hItem
            .if eax == tvhti.hItem
               INVOKE     SendMessage, hWndList, LVM_DELETEALLITEMS, 0, 0
                  and     hItem, 0
                  mov     byte ptr szProject, 0
            .endif
            INVOKE     SendMessage, hWndTree, TVM_DELETEITEM, 0, tvhti.hItem

;---------- [Updated the hProjArray for the deleted item] ----------
               mov     eax, tvhti.hItem
               mov     esi, hProjArray
               xor     edx, edx
               mov     ecx, ProjCnt
            .while (ecx)
               .if dword ptr[esi+edx+4] == eax
mov     dword ptr[esi+edx+4], 0
mov     byte ptr[esi+edx+8], 0
                  .break
               .endif
                  add     edx, 36
                  dec     ecx
            .endw

;---------- [Select the active Tree item] ----------
               mov     eax, hREdit
               mov     esi, hProjArray
               xor     edx, edx
               mov     ecx, ProjCnt
            .while (ecx)
               .if dword ptr[esi+edx] == eax
                     xor     ebx, ebx
                     mov     eax, dword ptr[esi+edx+4]
                     mov     bl, byte ptr[esi+edx+8]
                  .break
               .endif
                  add     edx, 36
                  dec     ecx
            .endw
            .if ecx && ebx == 1
                 push     eax
               INVOKE     LockWindowUpdate, hWnd
                  pop     eax
                  mov     FromTab, 1
               INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, eax
                  and     FromTab, 0
               INVOKE     LockWindowUpdate, 0
            .endif

         .endif
      .endif
         jmp     Ret0

Ret0:
         xor     eax, eax
         ret

TreeViewNotify ENDP

;=========================================================================
; Load the ListView with the file data PROCEDURE
;=========================================================================
LoadTreeView PROC lpFileName:DWORD, FromCode
LOCAL    tvis:TV_INSERTSTRUCT
LOCAL    lvf:LV_FINDINFO
LOCAL    lvi:LV_ITEM

      .if FromCode
            jmp     SelItem
      .endif
         mov     eax, hParent
         mov     tvis.hParent, eax
         mov     tvis.hInsertAfter, TVI_LAST
         mov     tvis.item.imask, TVIF_TEXT or TVIF_IMAGE or TVIF_SELECTEDIMAGE
         mov     eax, lpFileName
         mov     tvis.item.pszText, eax
         mov     tvis.item.iImage, 0
         mov     tvis.item.iSelectedImage, 1
      INVOKE     SendMessage, hWndTree, TVM_INSERTITEM, 0, addr tvis
         ret

SelItem:
;---------- [Sort and select the item in the Treeview
      INVOKE     SendMessage, hWndTree, TVM_EXPAND, TVE_EXPAND, hParent
      INVOKE     SendMessage, hWndTree, TVM_SORTCHILDREN, 0, hParent
      INVOKE     SendMessage, hWndTree, TVM_SELECTITEM, TVGN_CARET, hItem
      INVOKE     SendMessage, hWndTree, TVM_ENSUREVISIBLE, 0, hItem

;---------- [Select the item in the Listview
      .if FileName
            mov     lvf.flags, LVFI_STRING
            mov     lvf.psz, offset FileName
         INVOKE     SendMessage, hWndList, LVM_FINDITEM, -1, addr lvf
         .if eax != -1
               mov     lvi.iItem, eax
               mov     lvi.imask, LVIF_STATE
               mov     lvi.state, LVIS_SELECTED or LVIS_FOCUSED
               mov     lvi.stateMask, -1
            INVOKE     SendMessage, hWndList, LVM_SETITEMSTATE, lvi.iItem, addr lvi
         .endif
      .endif

         ret

LoadTreeView ENDP
;=========================================================================
; Load the ListView with the file data PROCEDURE
;=========================================================================
LoadListView PROC  uses edi row:DWORD, lpFileName, TypeF
LOCAL    lvi:LV_ITEM
LOCAL    szBuff0[64]:BYTE

         mov     edi, lpFileName

INVOKE     RtlZeroMemory, addr lvi, sizeof lvi

;---------- [Load the list items] ----------
         mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
        push     row
         pop     lvi.iItem
        push     row
         pop     lvi.lParam
         mov     lvi.iSubItem, 0
         mov     lvi.cchTextMax, 255
         lea     eax, [edi.WIN32_FIND_DATA].cFileName
         mov     lvi.pszText, eax
         mov     eax, TypeF
         mov     lvi.iImage, eax
;;;;      .if ProjOn
         INVOKE     SendMessage, hWndList, LVM_INSERTITEM, 0, addr lvi
;;;;      .endif
         ret
LoadListView ENDP

;=========================================================================
; Read the file PROCEDURE
;=========================================================================
ReadTheFile PROC uses edi Input:DWORD
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    lvf:LV_FINDINFO
LOCAL    lvi:LV_ITEM
LOCAL    hFind:DWORD, Pointer, Match
LOCAL    szBuff[256]:BYTE, szBuff1[64]:BYTE, szFolderE[64]:BYTE, szFileNameE[64]:BYTE

         and     Pointer, 0
         and     Match, 0
         and     Texe, 0
         and     Tdll, 0
         and     Tlib, 0
         and     Tinc, 0
         mov     byte ptr szFolderE, 0
         mov     byte ptr szFileNameE, 0

;---------- [Check if in a Root directory] ----------
      INVOKE     lstrcpy, addr szPathIn, Input
      INVOKE     lstrlen, addr szPathIn
         dec     eax
      .while (eax)
            dec     eax
         .if byte ptr szPathIn[eax] == '\'
            .if byte ptr szPathIn[eax-1] == ':'
;DSPValue hWnd, 1234, 1, 'm'
;INVOKE     MessageBox, NULL, addr szProjectP, addr AppName, MB_OK
            .endif
            .break
         .endif
      .endw

      .if !Run
         INVOKE     lstrcpy, addr szBuff, addr RootDir
         INVOKE     lstrcat, addr szBuff, addr szPointer
;;;;         .if ProjOn
            INVOKE     SendMessage, hWndList, LVM_DELETEALLITEMS, 0, 0
            INVOKE     lstrcat, addr szBuff, addr szProject
;;;;         .endif
         INVOKE     lstrcat, addr szBuff, addr PatnP+10  ; = .ptr

;---------- [See if there is a pointer file] ----------
         INVOKE     FindFirstFile, addr szBuff, addr FindData
         .if eax != INVALID_HANDLE_VALUE
            INVOKE     FindClose, eax
               mov     Pointer, 1
         .endif
      .endif

      INVOKE     lstrcpy, addr szBuff, Input
      INVOKE     lstrcpy, addr szPathIn, addr szBuff
      INVOKE     lstrcat, addr szBuff, addr szAll

;---------- [Check for mult exe's] ----------
      .if Run
         INVOKE     FindFirstFile, addr szBuff, addr FindData
         .if eax != INVALID_HANDLE_VALUE
               mov     hFind, eax
            .while (eax)
               .if byte ptr FindData.cFileName != '.'
                  INVOKE     lstrcpy, addr szBuff1, addr FindData.cFileName
                  INVOKE     lstrlen, addr szBuff1
                     sub     eax, 3
                  .if byte ptr szBuff1[eax] == 'e' && byte ptr szBuff1[eax+2] == 'e' ||\
                      byte ptr szBuff1[eax] == 'E' && byte ptr szBuff1[eax+2] == 'E'
                        inc     Texe
                  .endif
               .endif
               INVOKE     FindNextFile, hFind, addr FindData
            .endw
            INVOKE     FindClose, hFind
         .endif

;---------- [Get the folder name] ----------
         INVOKE     lstrlen, addr szPathIn
           push     eax
            dec     eax
         .while (eax)
               dec     eax
            .if byte ptr szPathIn[eax] == '\'
               .break
            .endif
         .endw
            pop     ecx
            sub     ecx, eax
            inc     eax
            dec     ecx
         INVOKE     lstrcpyn, addr szFolder, addr szPathIn[eax], ecx

;;;;.if ProjOn  ; $$$$
   INVOKE     lstrcpy, addr szFolder, addr szProject
;;;;.endif
         INVOKE     lstrcpy, addr szProjName, addr szFolder
         INVOKE     lstrcpy, addr szFolderE, addr szFolder
         INVOKE     lstrcat, addr szFolderE, addr szExe
         .if Run == 1
            INVOKE     lstrlen, addr FileName
               sub     eax, 3
            .if byte ptr FileName[eax] == '.' || byte ptr FileName[eax-1] == '.'
               .if byte ptr FileName[eax] == '.'
                     inc     eax
               .endif
               INVOKE     lstrcpyn, addr szFileNameE, addr FileName, eax
               INVOKE     lstrcat, addr szFileNameE, addr szExe
            .endif
         .endif
      .endif

      .if Run == 4
            ret
      .endif
;DSPValue hWnd, 7777, 1, 'm'
;INVOKE     MessageBox, NULL, addr szFolderE, addr AppName, MB_OK
;INVOKE     MessageBox, NULL, addr szFileNameE, addr AppName, MB_OK

      INVOKE     FindFirstFile, addr szBuff, addr FindData
      .if eax != INVALID_HANDLE_VALUE
            mov     hFind, eax
            xor     edi, edi
         .while eax != 0
            .if byte ptr FindData.cFileName != '.'
               .if (FindData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
               .else
                  INVOKE     lstrcpy, addr szBuff1, addr FindData.cFileName
                  INVOKE     lstrlen, addr szBuff1
                  .while (eax)
                     .if byte ptr szBuff1[eax] == '.'
                        .break
                     .endif
                        dec     eax
                  .endw
                  .if eax
                        inc     eax
                     .if byte ptr szBuff1[eax] >= 'A' && byte ptr szBuff1[eax] <= 'Z'
                           add     byte ptr szBuff1[eax], 20h
                     .endif
                     .if byte ptr szBuff1[eax+1] >= 'A' && byte ptr szBuff1[eax+1] <= 'Z'
                           add     byte ptr szBuff1[eax+1], 20h
                     .endif
                     .if byte ptr szBuff1[eax+2] >= 'A' && byte ptr szBuff1[eax+2] <= 'Z'
                           add     byte ptr szBuff1[eax+2], 20h
                     .endif

                     .if Run                ; Find the exe file
                        .if byte ptr szBuff1[eax] == 'e' && byte ptr szBuff1[eax+1] == 'x' &&\
                            byte ptr szBuff1[eax+2] == 'e'
                           .if Texe > 1 ; Mult exe's
                              INVOKE     lstrcmpi, addr szFolderE, addr FindData.cFileName
                              .if eax == 0
                                    inc     Match
                                 .if Run == 1
                                    INVOKE     lstrcat, Input, addr FindData.cFileName
                                    .break
                                 .endif
                              .else

                                 INVOKE     lstrcmpi, addr szFileNameE, addr FindData.cFileName
                                 .if eax == 0
                                       inc     Match
                                    .if Run == 1
                                       INVOKE     lstrcat, Input, addr FindData.cFileName
                                       .break
                                    .endif
                                 .else
                                       jmp     Pass
                                 .endif

                              .endif
                           .else
                                 inc     Match
                              .if Run == 1
                                 INVOKE     lstrcat, Input, addr FindData.cFileName
                                 .break
                              .endif
                                 jmp     Pass
                           .endif

                        .elseif Run == 2    ; Copy
                             push     eax
                           INVOKE     lstrlen, addr FindData.cFileName
                              sub     eax, 3
                           INVOKE     lstrcpyn, addr szBuff, addr FindData.cFileName, eax
                           INVOKE     lstrcmpi, addr szFolder, addr szBuff
                           .if eax != 0
                                 pop     eax
                                 jmp     Pass
                           .endif
                              pop     eax
                           .if byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'l' &&\
                               byte ptr szBuff1[eax+2] == 'l'
                                 inc     Tdll
                           .elseif byte ptr szBuff1[eax] == 'l' && byte ptr szBuff1[eax+1] == 'i' &&\
                               byte ptr szBuff1[eax+2] == 'b'
                                 inc     Tlib
                           .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n' &&\
                               byte ptr szBuff1[eax+2] == 'c'
                                 inc     Tinc
                           .else
                                 jmp     Pass
                           .endif          
;                           INVOKE     lstrcat, Input, addr FindData.cFileName
                              inc     Match
                        .else
                        .endif
                           jmp     Pass
                     .endif

                     .if FilterOn ;ProjOn ;Projects ;|| ProjOn     ; Get the files for the Listview
                        .if byte ptr szBuff1[eax] == 'a' && byte ptr szBuff1[eax+1] == 's' ||\
                            byte ptr szBuff1[eax] == 'r' && byte ptr szBuff1[eax+1] == 'c'
                        .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n' ||\
                            byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'e' ||\
                            byte ptr szBuff1[eax] == 'b' && byte ptr szBuff1[eax+1] == 'a'
                        .else
                              jmp     Pass
                        .endif
                     .endif

                     .if byte ptr szBuff1[eax] == 'a' && byte ptr szBuff1[eax+1] == 's'
                           mov     ecx, 2
                     .elseif byte ptr szBuff1[eax] == 'r' && byte ptr szBuff1[eax+1] == 'c'
                           mov     ecx, 5
                     .elseif byte ptr szBuff1[eax] == 'i' && byte ptr szBuff1[eax+1] == 'n'
                           mov     ecx, 6
                     .elseif byte ptr szBuff1[eax] == 'd' && byte ptr szBuff1[eax+1] == 'e'
                           mov     ecx, 3
                     .else
                           mov     ecx, 4
                     .endif

                     INVOKE     LoadListView, edi, addr FindData, ecx
                        inc     edi
                  .endif
               .endif
            .endif
Pass:
            INVOKE     FindNextFile, hFind, addr FindData
         .endw

;---------- [Load the Pointer item if available] ----------
         .if !Run && Pointer ;&& ProjOn
INVOKE     RtlZeroMemory, addr lvi, sizeof lvi

               mov     lvi.imask, LVIF_TEXT or LVIF_IMAGE or LVIF_PARAM
               mov     lvi.iItem, edi
               mov     lvi.lParam, edi
               mov     lvi.iSubItem, 0
;;;;            .if ProjOn
               INVOKE     lstrcpy, addr szBuff1, addr szProject
;;;;            .endif
            INVOKE     lstrcat, addr szBuff1, addr PatnP+10  ; = .ptr
               lea     eax, szBuff1
               mov     lvi.pszText, eax
               mov     lvi.iImage, 7
;;;;            .if ProjOn
               INVOKE     SendMessage, hWndList, LVM_INSERTITEM, 0, addr lvi
;;;;            .endif

jmp     Snap
            .if FileName
                  mov     lvf.flags, LVFI_STRING
                  mov     lvf.psz, offset FileName
               INVOKE     SendMessage, hWndList, LVM_FINDITEM, -1, addr lvf
               .if eax !=-1
                     mov     lvi.iItem, eax
                     mov     lvi.imask, LVIF_STATE
                     mov     lvi.state, LVIS_SELECTED or LVIS_FOCUSED
                     mov     lvi.stateMask, -1
                  INVOKE     SendMessage, hWndList, LVM_SETITEMSTATE, lvi.iItem, addr lvi
               .endif
            .endif
         .endif
Snap:

         INVOKE     FindClose, hFind
         .if Run && !Match
            INVOKE     MessageBox, NULL, addr szMsg01, addr szFolder, MB_OK or MB_ICONWARNING
         .endif
      .endif

         ret
ReadTheFile ENDP

;==========================================================================
; Builds the path to display in the Edit window from the Listview PROCEDURE
;==========================================================================
DisplayFileName PROC  ;uses ebx
LOCAL    lvi:LV_ITEM
LOCAL    tvi:TV_ITEM
LOCAL    SavItem:DWORD
LOCAL    ShFileOp:SHFILEOPSTRUCT
LOCAL    szBuff[256]:BYTE, szCurDir[256]:BYTE, szTabName[64]:BYTE

;      INVOKE     lstrcpy, addr szPathIn, addr szLoadPath
;         mov     tvi.imask, TVIF_HANDLE or TVIF_TEXT
;;;;      .if ProjOn
         INVOKE     SendMessage, hWndList, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
;;;;      .endif
      .if eax == -1
            ret
      .endif

mov     SavItem, eax
         mov     lvi.iItem, eax
         mov     lvi.iSubItem, 0
         mov     lvi.imask, LVIF_TEXT ;or LVIF_STATE
         lea     eax, szTabName
         mov     lvi.pszText, eax
         mov     lvi.cchTextMax, 63

;;;;      .if ProjOn
         INVOKE     SendMessage, hWndTree, TVM_GETNEXTITEM, TVGN_CARET, hItem
;;;;      .endif

         mov     tvi.hItem, eax
;;;;.if ProjOn  ; $$$$
         lea     eax, szProject
;;;;.endif
         mov     tvi.pszText, eax
         mov     tvi.cchTextMax, 63

;;;;      .if ProjOn
         INVOKE     SendMessage, hWndList, LVM_GETITEM, 0, addr lvi
         INVOKE     SendMessage, hWndTree, TVM_GETITEM, 0, addr tvi
;;;;      .endif

      INVOKE     lstrlen, addr szTabName
      .if byte ptr szTabName[eax-3] == 'p' && byte ptr szTabName[eax-1] == 'r'
         INVOKE     lstrcpy, addr szBuff, addr RootDir
         INVOKE     lstrcat, addr szBuff, addr szPointer
      .elseif ;;;;ProjOn
         INVOKE     lstrcpy, addr szBuff, addr szLoadPath
      .endif

;---------- [Delete File] ----------
      .if Run == 75
         INVOKE     MessageBox, NULL, addr szDeleteF, addr szTabName, MB_YESNO or\
                    MB_ICONWARNING or MB_TASKMODAL
         .if eax == IDNO
               jmp     Ret0
         .endif
         INVOKE     RtlZeroMemory, addr ShFileOp, sizeof ShFileOp
         INVOKE     GetCurrentDirectory, lengthof szCurDir, addr szCurDir
         INVOKE     SetCurrentDirectory, addr szBuff

         INVOKE     lstrlen, addr szTabName
            inc     eax
            mov     szTabName[eax], 0       ; Insert additional terminator
            mov     ShFileOp.wFunc, FO_DELETE
            mov     ShFileOp.hwnd, 0     ; If 0, then no parent can task switch away
            lea     eax, szTabName
            mov     ShFileOp.pFrom, eax
            mov     ShFileOp.fFlags, FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR
         INVOKE     SHFileOperation, addr ShFileOp
         .if eax != 0
;            INVOKE     MessageBox, NULL, addr szError9, addr pTitle, MB_OK or MB_ICONWARNING
         .else
;;;;            .if ProjOn
               INVOKE     SendMessage, hWndList, LVM_DELETEITEM, SavItem, 0
;;;;            .endif
         .endif
            INVOKE     SetCurrentDirectory, addr szCurDir
               ret
      .endif

      INVOKE     lstrcat, addr szBuff, addr szTabName
      INVOKE     lstrcpy, addr PathName, addr szBuff
      INVOKE     lstrcpy, addr FileName, addr szTabName

Ret0:

         xor     eax, eax
         ret
DisplayFileName ENDP

;=========================================================================
; Delete project PROCEDURE
;=========================================================================
DelProj  PROC  uses ebx esi edi  PNane:DWORD, w1
LOCAL    FindData:WIN32_FIND_DATA
LOCAL    ShFileOp:SHFILEOPSTRUCT
LOCAL    hReg:DWORD, hFind, hFile, Bytesread, SPos1, sw, NoFile
LOCAL    szBuff0[256]:BYTE, szBuff1[256]:BYTE, szBuff2[256]:BYTE, szCurDir[256]:BYTE, Misc[40]:BYTE

      INVOKE     RtlZeroMemory, addr ShFileOp, sizeof ShFileOp
         and     NoFile, 0

;      .if eax == ERROR_SUCCESS
         INVOKE     lstrcpy, addr szBuff0, addr AsmRootDir
         INVOKE     lstrcat, addr szBuff0, addr szPointer
         INVOKE     lstrcat, addr szBuff0, PNane
         INVOKE     lstrcat, addr szBuff0, addr PatnP+10  ; = .ptr
         INVOKE     lstrcpy, addr szBuff1, addr AsmRootDir
         INVOKE     lstrcat, addr szBuff1, addr szProjects
         INVOKE     lstrcat, addr szBuff1, PNane
         INVOKE     lstrcat, addr szBuff1, addr szBackS
         INVOKE     GetCurrentDirectory, lengthof szCurDir, addr szCurDir
         INVOKE     SetCurrentDirectory, addr szBuff1

         .if w1 == 4444                         ; From the Project Tree
            INVOKE     DialogBoxParam, hInst, addr DlgName4, hWnd, addr ChkDelProj, 0
            .if !DeleteOn
                  jmp     DelDone

            .elseif DeleteOn == 2               ; Delete pointer file only
               INVOKE     lstrcpy, addr szBuff1, addr szBuff0
                  mov     sw, 1
                  jmp     LoopDel
            .endif
         .endif

;---------- [Delete the complete Project
         INVOKE     lstrcat, addr szBuff1, addr szAll

;---------- [Read the pointer file
         INVOKE     CreateFile, addr szBuff0,\
                    GENERIC_READ or GENERIC_WRITE ,\
                    FILE_SHARE_READ or FILE_SHARE_WRITE,\
                    0, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, 0
         .if eax == -1
               jmp     DelDone
         .endif
            mov     hFile, eax
         INVOKE     GlobalAlloc, GMEM_MOVEABLE or GMEM_ZEROINIT, 100000
            mov     hpMem, eax
         INVOKE     GlobalLock, hpMem
            mov     fpMem, eax
         INVOKE     ReadFile, hFile, fpMem, 100000, addr Bytesread, NULL
         INVOKE     CloseHandle, hFile

            mov     al, 3ah               ; Colon
            mov     ecx, Bytesread        ; Bytes left to analyze
            mov     edi, fpMem            ; Start address in input buffer
            mov     SPos1, edi
            cld                           ; Increment edi
          repnz     scasb                 ; Repeat until byte = al(3ah)
            mov     eax, edi
            sub     eax, fpMem
           push     eax
         INVOKE     lstrcpyn, addr Misc, SPos1, eax
            pop     eax
            inc     eax
            add     SPos1, eax
            mov     ecx, eax
            mov     eax, 256 ;Bytesread
            sub     eax, ecx
            inc     eax

            mov     ecx, 256 ;20
            mov     ebx, SPos1
         .while (ecx)
            .if byte ptr [ebx+eax] == '\'
               .break
            .endif
               dec     eax
               dec     ecx
         .endw
         .if !ecx
               mov     NoFile, 1
         .endif
            add     eax, 2

;---------- [Check for a drive letter] ----------
            mov     ebx, SPos1
         .if byte ptr [ebx+1] != ':'
              push     eax
            INVOKE     lstrcpyn, addr szBuff2, addr AsmRootDir, 3
               pop     eax
            INVOKE     lstrcpyn, addr szBuff2+2, SPos1, eax
         .else
            INVOKE     lstrcpyn, addr szBuff2, SPos1, eax
         .endif

         INVOKE     GlobalUnlock, fpMem
         INVOKE     GlobalFree, hpMem

         .if NoFile
            INVOKE     lstrcpy, addr szBuff1, addr szBuff0
               mov     sw, 1
               jmp     LoopDel
         .endif
;      .else
; Do message
;            jmp     DelDone
;      .endif

      INVOKE     MessageBox, NULL, addr szError7, addr AppName, MB_YESNO or MB_ICONQUESTION
      .if eax == IDNO
            jmp     DelDone
      .endif

;---------- [Make sure the files are not in the root directory] ----------
      INVOKE     lstrlen, addr szBuff1
         mov     ecx, eax
         xor     eax, eax
         xor     edx, edx
      .while (ecx)
         .if byte ptr szBuff1[eax] == '\'
               inc     edx
         .endif
            inc     eax
            dec     ecx
      .endw
      .if edx < 3
         INVOKE     lstrcpy, addr szBuff1, addr szBuff0
            mov     sw, 1
            jmp     LoopDel
      .endif

;---------- [Find First File in the Project Folder] ----------
      INVOKE     FindFirstFile, addr szBuff1, addr FindData
      .if eax == -1
         INVOKE     MessageBox, NULL, addr szError8, addr AppName, MB_YESNO or MB_ICONWARNING
         .if eax == IDNO
               jmp     SetCurr
         .endif
            INVOKE     SetCurrentDirectory, addr szCurDir
            INVOKE     GetCurrentDirectory, lengthof szCurDir, addr szCurDir
            INVOKE     lstrcpy, addr szBuff1, addr szBuff2
            INVOKE     SetCurrentDirectory, addr szBuff1
            INVOKE     lstrcat, addr szBuff1, addr szAll

;---------- [Find First File in a non-Project Folder] ----------
            INVOKE     FindFirstFile, addr szBuff1, addr FindData
            .if eax == -1
; Do message
                  jmp     CloseIt ;SetCurr
            .endif
      .endif
         mov     hFind, eax
         jmp     ChkFile

;---------- [Find Next File] ----------
GetNext:
      INVOKE     FindNextFile, hFind, addr FindData
        test     eax, eax
          jz     CloseIt

;---------- [Validate File] ----------
ChkFile:
      .if byte ptr FindData.cFileName == '.'
            jmp     GetNext
      .endif

;---------- [Delete File(s)] ----------
      INVOKE     lstrlen, addr FindData.cFileName
         inc     eax
         mov     FindData.cFileName[eax], 0  ; Insert additional terminator
         mov     ShFileOp.wFunc, FO_DELETE
         mov     ShFileOp.hwnd, 0            ; If 0, then no parent can task switch away
         lea     eax, FindData.cFileName
         mov     ShFileOp.pFrom, eax
         mov     ShFileOp.fFlags, FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR
      INVOKE     SHFileOperation, addr ShFileOp
      .if eax != 0
         INVOKE     MessageBox, NULL, addr szError9, addr AppName, MB_OK or MB_ICONWARNING
         INVOKE     FindClose, hFind
            jmp     SetCurr
      .endif
         jmp     GetNext

CloseIt:
      INVOKE     FindClose, hFind
         and     sw, 0


;---------- [Delete the Folder] ----------
      INVOKE     lstrlen, addr szBuff1
         sub     eax, 3
      INVOKE     lstrcpyn, addr szBuff1, addr szBuff1, eax

LoopDel:
      INVOKE     lstrlen, addr szBuff1
         inc     eax
         mov     szBuff1[eax], 0             ; Insert additional terminator
         mov     ShFileOp.wFunc, FO_DELETE
         mov     ShFileOp.hwnd, 0            ; If 0, then no parent can task switch away
         lea     eax, szBuff1
         mov     ShFileOp.pFrom, eax
         mov     ShFileOp.fFlags, FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOCONFIRMMKDIR
      INVOKE     SHFileOperation, addr ShFileOp
      .if eax != 0 && !sw
         INVOKE     MessageBox, NULL, addr szError10, addr AppName, MB_OK or MB_ICONWARNING
;            jmp     SetCurr
      .endif

      .if !sw
            inc     sw
         INVOKE     lstrcpy, addr szBuff1, addr szBuff0
            jmp     LoopDel                  ; Delete the pointer file
      .endif
      .if w1 == 4444                         ; From the Project Tree
            jmp     SetCurr
      .endif
;      INVOKE     SendMessage, hAsmbox, LB_DELETESTRING, w1, 0

SetCurr:
      INVOKE     SetCurrentDirectory, addr szCurDir
      .if w1 == 4444                         ; From the Project Tree
            mov     eax, w1
            ret
      .endif

DelDone:
         mov     eax, FALSE

         ret
DelProj  Endp

;=========================================================================
; Check project delete type PROCEDURE
;=========================================================================
ChkDelProj proc  hdlg:DWORD, wMsg, wParam, lParam

      .if wMsg == WM_INITDIALOG
         INVOKE     CheckRadioButton, hdlg, 71, 72, 72
         INVOKE     GetDlgItem, hdlg, 1911
         INVOKE     SetFocus, eax

      .elseif wMsg == WM_COMMAND
         .if wParam == 71 || wParam == 72
            INVOKE     GetDlgItem, hdlg, 1911
            INVOKE     SetFocus, eax
         .endif

         .if wParam == 81
               mov     DeleteOn, 2
            INVOKE     IsDlgButtonChecked, hdlg, 71 ; Delete the complete project
            .if eax
                  mov     DeleteOn, 1
            .endif
               jmp     GetOut

         .elseif wParam == 82
               and     DeleteOn, 0
               jmp     GetOut
         .endif

      .elseif wMsg == WM_CLOSE

GetOut:
         INVOKE     EndDialog, hdlg, 0
            mov     eax, TRUE
            ret
      .endif

Ret0:
         xor     eax, eax
         ret

ChkDelProj endp
